import {select, csv, scaleLinear, scaleBand, max} from 'd3';
const svg = select('svg');
const width=+svg.attr('width');
const height=+svg.attr('height');

const render = data => {
  const xValue = d => d.population;
  const yValue = d => d.country;
  console.log('hey');
  console.log(data);
  console.log(max(data, xValue));
  // makes a d3 selection that selects all rectangles on the page
  // d3 data join
  // make a linear scalar object
  const xScale = scaleLinear()
  	// min and ax
    // max(data, d => d.population)
  	.domain([0, max(data, xValue)])
    // max height of a bar should be the width of our svg container
  	.range([0, width])
  ;
  
  // Will arrange the rectangles from top to bottom on the page
  // bandwidth is the computer width of a single bar
  const yScale = scaleBand()
    // data.map(d => d.country)
  	.domain(data.map(yValue)) // like ["China", "India", etc.
  	.range([0, height])
  ;
  
  console.log('Test', data.map(yValue));
  
  console.log('Y-Scale domain: ', yScale.domain());
  console.log('Min and Max: ', xScale.domain())
  console.log('Bar size range', xScale.range())
  console.log('Y-scale band', yScale.bandwidth());
  
  
  svg.selectAll('rect').data(data)
  	.enter().append('rect')
    // yScale(d.country)
  	.attr('y', d => yScale(yValue(d)))
    // xScale(d.population)
  	.attr('width', d => xScale(xValue(d)))
  	.attr('height', yScale.bandwidth())
  
};


// Returns a promise, that returns when the data is loaded
csv('data.csv').then(data => {
  data.forEach( d => {
    // parse string into numbers, and represent it as actual amount
    d.population = +d.population * 1000;
  });
  render(data);
});
